%define debug_package %{nil}
%define cecilver %(gacutil -l Mono.Cecil |grep Mono.Cecil |cut -d "=" -f 2 |cut -d "," -f 1)
%define ceciltoken %(gacutil -l Mono.Cecil |grep Mono.Cecil |cut -d "=" -f 4)

Summary: A native OODBMS for Java/.NET/Mono - Mono version
Name: db4o
Version: 7.4
Release: 2%{?dist}
License: GPLv2
Patch0: db4o-74-make.patch
Group: Development/Libraries
Source: %{name}-%{version}-net2.zip
URL: http://www.db4o.com/
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: mono-devel, mono-cecil-flowanalysis-devel

ExclusiveArch: %ix86 x86_64 ia64 armv4l sparc alpha s390 s390x

%description
Embed db4o's native Java or .NET/Mono open source object database
engine into your product and experience unparalleled ease-of-use.
db4o is simple to install, integrate, and deploy.

%package doc
Summary: Documentation and API for db4o
Requires: %{name} = %{version}-%{release}
Group: Documentation

%description doc
Tutorials and API documentation for db4o

%package devel
Summary: Development file for db4o
Requires: %{name} = %{version}-%{release} pkgconfig
Group: Development/Libraries

%description devel
Development files for db4o

%prep
%setup -q 
%patch0 -p1 -b .makepatch
#sed -i 's/\r//' doc/tutorial/vb/index.html
#sed -i 's/\r//' doc/tutorial/index.html
sed 's!/usr/lib!%{_libdir}!' -i src/Makefile
rm -rf src/Libs/*
sed -i 's|Mono.Cecil.dll|%{_libdir}/mono/gac/Mono.Cecil/%{cecilver}__%{ceciltoken}/Mono.Cecil.dll|' src/include.mk
sed -i 's|Cecil.FlowAnalysis.dll|%{_libdir}/mono/Cecil.FlowAnalysis/Cecil.FlowAnalysis.dll|' src/include.mk
sed -i 's|Mono.GetOptions.dll|%{_libdir}/mono/2.0/Mono.GetOptions.dll|' src/include.mk

%build
rm -rf %{buildroot}
cd src
make 

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_libdir}/pkgconfig
mkdir -p %{buildroot}/%{_libdir}/mono/gac
mkdir -p %{buildroot}/%{_bindir}
gacutil -i src/bin/Db4objects.Db4o.dll -f -package db4o -root %{buildroot}%{_libdir}
gacutil -i src/bin/Db4objects.Db4o.Instrumentation.dll -f -package db4o -root %{buildroot}%{_libdir}
gacutil -i src/bin/Db4objects.Db4o.Linq.dll -f -package db4o -root %{buildroot}%{_libdir}
gacutil -i src/bin/Db4objects.Db4o.NativeQueries.dll -f -package db4o -root %{buildroot}%{_libdir}
gacutil -i src/bin/Db4oUnit.dll -f -package db4o -root %{buildroot}%{_libdir}
gacutil -i src/bin/Db4oUnit.Extensions.dll -f -package db4o -root %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_libdir}/mono/db4o
cp src/bin/* %{buildroot}%{_libdir}/mono/db4o

cat <<EOF >%{buildroot}/%{_libdir}/pkgconfig/db4o.pc
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}

Name: db4o
Description: db4o - an object based database system
Version: 7.4
Libs: -r:%{_libdir}/mono/db4o/Db4objects.Db4o.dll, -r:%{_libdir}/mono/db4o/Db4oUnit.dll, -r:%{_libdir}/mono/db4o/Db4objects.Db4o.Instrumentation.dll, -r:%{_libdir}/mono/db4o/Db4oUnit.Extensions.dll -r:%{_libdir}/mono/db4o/Db4objects.Db4o.Linq.dll -r:%{_libdir}/mono/db4o/Db4objects.Db4o.NativeQueries.dll
EOF

cat <<EOF >%{buildroot}/%{_bindir}/Db4oTool
#!/bin/sh
env mono %{_libdir}/mono/db4o/Db4oTool.exe "$@"
EOF

cat <<EOF >%{buildroot}/%{_bindir}/Db4oTool-Tests
#!/bin/sh
env mono %{_libdir}/mono/db4o/Db4oTool.Tests.exe "$@"
EOF

cat <<EOF >%{buildroot}/%{_bindir}/Db4o-LinqTests
#!/bin/sh
env mono %{_libdir}/mono/db4o/Db4objects.Db4o.Linq.Tests.exe "$@"
EOF

cat <<EOF >%{buildroot}/%{_bindir}/Db4o-LinqInstrumentationTests
#!/bin/sh
env mono %{_libdir}/mono/db4o/Db4objects.Db4o.Linq.Instrumentation.Tests.exe "$@"
EOF

cat <<EOF >%{buildroot}/%{_bindir}/Db4oTests
#!/bin/sh
env mono %{_libdir}/mono/db4o/Db4objects.Db4o.Tests.exe "$@"
EOF

chmod 755 %{buildroot}/%{_bindir}/Db4oTool
chmod 755 %{buildroot}/%{_bindir}/Db4oTool-Tests
chmod 755 %{buildroot}/%{_bindir}/Db4o-LinqTests
chmod 755 %{buildroot}/%{_bindir}/Db4o-LinqInstrumentationTests
chmod 755 %{buildroot}/%{_bindir}/Db4oTests

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_bindir}/*
%{_libdir}/mono/db4o/
%{_libdir}/mono/gac/Db4*

%files doc
%doc doc/*

%files devel
%{_libdir}/pkgconfig/db4o.pc

%changelog
* Wed Jan 20 2010 Paul F. Johnson <paul@all-the-johnsons.co.uk> 7.4-2
- Fix the names for the files the binaries link to

* Wed Jan 20 2010 Paul F. Johnson <paul@all-the-johnsons.co.uk> 7.4-1
- Big update
- Fix URL
- Lots of spec file fixes

* Fri Apr 10 2009 Paul F. Johnson <paul@all-the-johnsons.co.uk> 6.1-5
- Alter excludearch to exclusivearch
- Remove ppc build

* Thu Feb 05 2009 Paul F. Johnson <paul@all-the-johnsons.co.uk> 6.1-4.1
- rebuild

* Wed Apr  9 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 6.1-4
- rework package to use system libraries, not bundled binary copies

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 6.1-3
- Autorebuild for GCC 4.3

* Tue Feb 06 2007 Paul F. Johnson <paul@all-the-johnsons.co.uk> 6.1-2
- bump
- spec file fixes
- new scripts for usr-bin links to the libdir

* Thu Nov 23 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 6.0.3-2
- corrected the pc file

* Wed Nov 22 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 6.0.3-1
- bump to new dev version
- minor spec file fixes

* Wed Aug 24 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 5.5-10
- Removed monodir hack
- Added makefile patch
- Added release requirement for docs subpackage

* Wed Aug 09 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 5.5-8
- Fixed a few other bits
- Changed from Dev/Doc to just Doc for the doc package
- Removed debug-package (empty)
- Added R pkg-config to the devel package

* Tue Aug 08 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 5.5-6
- Added back in the gac lines. D'oh! Must read docs fully---must read docs...

* Tue Aug 08 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 5.5-5
- Removed the gacutil entry
- Fixed binary duplicates
- Added pc file (means that -pkg:db4o can now be used on the command line)

* Tue Aug 08 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 5.5-2
- Fixed source URL
- removed R mono
- added documentation subpackage

* Mon Aug 07 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> 5.5-1
- initial import to FE
- many changes to spec file to comply with FE packaging
- added gacutil line to the build

